;=============================CARRITO.asm===========22 de Junio del 2001=====
;PARA SER USADO EN LA TARJETA Modulo de 5 entradas y 3 salidas con relevador
;5i-30r Clave 703
;-------------------------------------------------------------------------

portb           equ     0x06

ncount          equ     0x0c	;registro interno de paus_100ms
mcount          equ     0x0d	;registro externo de paus_100ms
pcount		equ	0x0e	;registro de npause_100ms

rcount		equ	0x0f	;registro mas interno de paus_1s
scount		equ	0x10	;registro medio de paus_1s
tcount		equ	0x11	;registro externo de paus_1s
ucount		equ	0x12	;registro de npaus_1s

count1		equ	0x13	;registro mas interno de paus_1m
count2		equ	0x14	;registro medio de paus_1m
count3		equ	0x15	;registro externo de paus_1m
count4		equ	0x16	;registro mas externo de paus_1m
count5		equ	0x17	;registro de npaus_1m
veces		equ	0x18

IntIzq		equ	0x0
IntDer		equ	0x1
	
		#define	MotorAdelante	bsf	portb,5
		#define	MotorAtras	bsf	portb,7
		#define PararMotor	clrf	portb

;----------------------------------------------------------------------------						
;MACROS
;----------------------------------------------------------------------------
OutPuerto	macro		SalidaGeneral		;SalidaGeneral b'00000000'
		movlw		SalidaGeneral		;De izq. a derecha son las salidas 1 a 7
		movwf		portb
		endm

Minutos		macro		min			; d'1'< min < d'255'
		movlw		min
		movwf		count5
		call		npaus_1m		
		endm

Segundos	macro		seg			; d'1'< seg < d'255'		
		movlw		seg
		movwf		ucount
		call		npaus_1s		
		endm

Miliseg		macro		miliseg			; d'1'< miliseg < d'255'
		movlw		miliseg
		movwf		pcount
		call		npaus_100ms
		endm 

Timer		macro		min,seg,miliseg
		if min>0
		Minutos  	 min
		endif
		
		if seg>0
		Segundos  	 seg
		endif

		if miliseg>0
		Miliseg		miliseg
		endif
		endm

Repite		macro		Repeticiones		;Carga numero de repeticiones en veces
		movlw		Repeticiones		;1< Repeticiones <255
		movwf		veces
		endm

RepitiendoDesde	macro		Etiqueta
		decfsz		veces,f
		goto		Etiqueta
		endm
;----------------------------------------------------------------------------

                org             0x000
						

		movlw           b'00011111'	
                tris            portb      	;Define como salida al PuertoB
	
		clrf		portb		;Apaga el puerto B

		goto		Programa
;----------------------------------------------------------------------------
;SUBRUTINAS
;----------------------------------------------------------------------------
;paus_100ms es una pausa de 100 mili segundos = a .1 seg
paus_100ms      movlw   0x82            
                movwf   mcount          
loadn           movlw   0xff            
                movwf   ncount          
decn            decfsz  ncount,f        
                goto    decn            
                decfsz  mcount,f        
                goto    loadn           
                return                  
;----------------------------------------------------------------------------
;npause_100ms repite 100ms las veces que contenga el registro pcount
;antes de entrar cargar el registro pcount con el numero deseado
npaus_100ms     call	paus_100ms
		decfsz	pcount,f
		goto	npaus_100ms
		return
;----------------------------------------------------------------------------
;paus_1s es una pausa de 1 segundo
paus_1s		movlw	0x0a		;carga
		movwf	tcount		;tcount
loads		movlw   0x82            ;carga
                movwf   scount          ;scount
loadr           movlw   0xff            ;carga
                movwf   rcount          ;rcount
decr            decfsz  rcount,f        ;decrementa r
                goto    decr            ;again
                decfsz  scount,f        ;decrementa s
                goto    loadr           ;again
		decfsz	tcount		;decrementa t
		goto	loads		
                return                  
;----------------------------------------------------------------------------
;npause_1s repite 1s las veces que contenga el registro ucount
;antes de entrar cargar el registro pcount con el numero deseado
npaus_1s        call	paus_1s
		decfsz	ucount,f
		goto	npaus_1s
		return

;----------------------------------------------------------------------------
;paus_1m es una pausa de 1 minuto

paus_1m		movlw	0x3c		;carga 60 decimal
		movwf	count4		;count4
load3		movlw	0x0a		;carga
		movwf	count3		;count3

load2		movlw   0x82            ;carga 82 se ADELANTA .060
                movwf   count2          ;count2
load1           movlw   0x00		;carga
                movwf   count1          ;count1
dec1            decfsz  count1,f        ;decrement 1
                goto    dec1            ;again
                decfsz  count2,f        ;decrement 2
                goto    load1           ;again
		decfsz	count3		;decrement 3
		goto	load2		;again
		decfsz	count4		;decrement 3
		goto	load3		;again
                return                  ;done
;----------------------------------------------------------------------------
;npause_1m repite 1m las veces que contenga el registro count5
;antes de entrar cargar el registro count5 con el numero deseado
npaus_1m        call	paus_1m
		decfsz	count5,f
		goto	npaus_1m
		return
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
Programa

		MotorAtras

ChecaIntIzqActivado
		btfsc	portb,IntIzq		;Salta la siguiente instruccion si..
		goto	ChecaIntIzqActivado

		PararMotor

		Segundos d'10'			;Pausa de 10 segundos

		MotorAdelante

ChecaIntDerActivado
		btfsc	portb,IntDer
		goto	ChecaIntDerActivado

		PararMotor

		Segundos d'10'

		goto	Programa
		

		end


